#
# OBJET  : Analyse du fichier d'activite IG Maktets order_history_jjmmaaaa_hhmnss.csv
# AUTEUR : Alain LL
# Version 3 : 	21/03/2012	Stat sur les trades : positifs, ngatifs et % efficacit
# Version 4 : 	21/04/2012	Duree d'exposition au march
# Version 5 : 	25/04/2012	Mise de cot des positions over night (OVN)
# Version 6 :	26/04/2012	Support du format de UTF16, et parametrage des valeurs de contrat dans contrat.txt
#

#--- Parametres
$FIC="order.csv";
$DATA="contrats.txt";
$SEUIL = 2;

open(IN, "<:encoding(UTF-16)", $FIC) || die("PB ouverture $FIC");
open(OUT, ">" , "res.txt");

$odate="-";
$pv_jour = 0; $positif = 0; $negatif = 0; 	
$duree_tr = 0; $nb_tr = 0;


#--- chargement des prix des contrats depuis un fichier UTF-16 (format : valeur; nom_contrat;)
open(DT, "<:encoding(UTF-16)", $DATA) || die("PB ouverture $DATA");
while ( <DT> )
{
	($valeur, $contrat) = ( $_ =~/([^;]+)/g ) ;
	$prix { $contrat } = $valeur;
}
close DT;

#--- lecture du fichier des transactions IGM
while ( <IN> )
{
	($date, $time, $type, $contrat, $echance, $canal, $devise, $qte, $cours, 
		$stop, $type_stop, $limite, $res)  = ( $_ =~/([^\t]+)/g ) ;
	#printf OUT "DATE $date / TIME $time / TYPE $type / CONTRAT $contrat \n" ;

# reference transaction
	if ($res =~ /.*: (\w+)/) { $ref = $1; }

# changemement de jour
	if ($odate != $date) {
		if ($odate != "-") {	do_total();	}
		printf OUT "\n==================== $date ==================== \n";
		$odate = $date;
	}


	if (/Position ouverte:/) {
		$cours_close = $my_cours {$ref};
		$time_close = $my_time {$ref};
		$date_close = $my_date {$ref};
		$libel = substr($contrat, 0, 12);
		if ($cours_close > 0)
		{
			$bilan = $qte * ($cours_close - $cours);
			$pv = $bilan * $prix {$contrat};
			if ($pv > 0) { $positif += 1; }
			if ($pv < 0) { $negatif += 1; }
			$pv_jour += $pv;

			#--- duree d'exposition au marche
			if ($date != $date_close)
			{
				$info = "++ OVN";
			}
			else {
				$hhmn_close = substr($time_close, 0, 2)*60 + substr($time_close, 3, 2);
				$hhmn_open  = substr($time, 0, 2)*60 + substr($time, 3, 2);
				$duree = $hhmn_close - $hhmn_open;
				$duree_tr += $duree;
				$nb_tr += 1;

				if ($duree > $SEUIL)	{	$info = sprintf "%smn", $duree;	} 
				else 			{	$info = "-";			}
			}

			printf OUT "%s  %s   %+.2f   %7s   OPEN  %s / %s %7s = %+6.2f /  %+7.2f  %s\n", 
				$ref, $libel, $qte, $cours, $time,
				$time_close, $cours_close, $bilan, $pv, $info ;
		}
		else {
			printf OUT "%s  %s   %+.2f   %7s   OPEN  %s / \n", 
				$ref, $libel, $qte, $cours, $time;


		}
	}

	if (/ferme\(s\)/) {
#		printf OUT "CLOSE %s %.35s %+.2f %6s %s\n", $time, $contrat, $qte, $cours, $ref;
		$my_cours {$ref} = $cours;
		$my_time {$ref} = $time;
		$my_date {$ref} = $date;

	}

	$n += 1;


}
do_total();


#-------------------
sub do_total() 
{

	if ($positif+$negatif > 0 && $nb_tr > 0) {
		printf OUT "\nResultat = %+.2f  (+)%d  (-)%d  efficacite %d%% exposition %dmn soit %.1fmn/TR\n", 
			$pv_jour, $positif, $negatif, $positif*100/($positif+$negatif), $duree_tr, $duree_tr/$nb_tr;
	} else {
		printf OUT "\nResultat = %+.2f  (+)%d  (-)%d  exposition %dmn\n", 
			$pv_jour, $positif, $negatif, $duree_tr;
	}
	$pv_jour = 0; 
	$positif = 0; 
	$negatif = 0;
	$duree_tr = 0;
	$nb_tr = 0;
}
